// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/base"
	model "LAPP_LF_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : AttributeGroupValstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : AttributeGroupValst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 12:11:47
 *
 ******************************************************************************/
type AttributeGroupValstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewAttributeGroupValstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个AttributeGroupValstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : AttributeGroupValstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 12:11:47
 *
 ******************************************************************************/
func NewAttributeGroupValstDAOImplement(session *xorm.Session, plantNr int, userid string) *AttributeGroupValstDAOImplement {
	return &AttributeGroupValstDAOImplement{session, &meta.AttributeGroupValst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) InsertOne(entity *model.AttributeGroupValst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) DeleteOne(attrCode int, attrGrpCode int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, attrCode, attrGrpCode}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) SelectOne(attrCode int, attrGrpCode int) (*model.AttributeGroupValst, error) {
	var data model.AttributeGroupValst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, attrCode, attrGrpCode}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) UpdateOne(entity *model.AttributeGroupValst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.Insert
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) Insert(entities *[]model.AttributeGroupValst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.Delete
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) Delete(entities *[]model.AttributeGroupValst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.AttributeGroupValst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.Select
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.AttributeGroupValst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.AttributeGroupValst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.AttributeGroupValst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.AttributeGroupValst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.AttributeGroupValst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.AttributeGroupValst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.AttributeGroupValst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.Update
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) Update(entities *[]model.AttributeGroupValst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.AttributeGroupValst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.AttributeGroupValst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.AttributeGroupValst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.SelectAllot
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) SelectAllot(attrGrpCode int) ([]model.Attribute, error) {

	data := make([]model.Attribute, 0)
	session := impl.session.Table(meta.Attribute.TableName).Join("LEFT", meta.AttributeGroupValst.TableName, "AttributeGroupValst.PlantNr = Attribute.PlantNr and AttributeGroupValst.AttrCode = Attribute.AttrCode").Where("AttributeGroupValst.PlantNr = ? and AttributeGroupValst.AttrGrpCode = ?", impl.plantNr, attrGrpCode)

	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/AttributeGroupValstDAO.SelectUnAllot
 *
 ******************************************************************************/
func (impl *AttributeGroupValstDAOImplement) SelectUnAllot(attrCodes []int) ([]model.Attribute, error) {

	data := make([]model.Attribute, 0)
	session := impl.session.Table(meta.Attribute.TableName).Where("PlantNr = ?", impl.plantNr).NotIn("AttrCode", attrCodes)

	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}
